package com.yiyon.reimburse.service;

package ..deTemp.1741741451794;

import com.google.common.collect.Lists;
import com.yiyon.basedata.entity.DataKeyanProject;
import com.yiyon.basedata.entity.DataProject;
import com.yiyon.basedata.entity.DataReimbursement;
import com.yiyon.basedata.service.DataAuditDetailRecordService;
import com.yiyon.basedata.service.DataKeyanProjectService;
import com.yiyon.basedata.service.DataProjectService;
import com.yiyon.basedata.service.DataProjectTypeService;
import com.yiyon.basedata.service.DataReimbursementService;
import com.yiyon.budget.entity.BudgetControl;
import com.yiyon.budget.entity.BudgetExecute;
import com.yiyon.budget.listener.OperateEntity;
import com.yiyon.budget.service.BudgetControlService;
import com.yiyon.budget.service.BudgetExecuteService;
import com.yiyon.reimburse.dao.BusiCcApplyDao;
import com.yiyon.reimburse.entity.BusiCcApply;
import com.yiyon.reimburse.entity.BusiCcApplyDetail;
import com.yiyon.reimburse.entity.BusiCcReimbur;
import com.yiyon.reimburse.entity.BusiCcReimburBudgetDetail;
import com.yiyon.reimburse.entity.BusiEnclosure;
import com.yiyon.reimburse.service.BaseService;
import com.yiyon.reimburse.service.BusiCcApplyDetailService;
import com.yiyon.reimburse.service.BusiCcReimburBudgetDetailService;
import com.yiyon.reimburse.service.BusiEnclosureService;
import com.yiyon.reimburse.service.BusiExpenseCashierService;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.function.BiConsumer;
import java.util.stream.Collectors;
import javax.annotation.PostConstruct;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.roseboy.jeee.activiti.service.ActivitiService;
import net.roseboy.jeee.activiti.service.AuditService;
import net.roseboy.jeee.admin.entity.Depart;
import net.roseboy.jeee.admin.entity.User;
import net.roseboy.jeee.admin.service.BillNoService;
import net.roseboy.jeee.admin.service.DepartService;
import net.roseboy.jeee.admin.service.RoleService;
import net.roseboy.jeee.admin.service.UserService;
import net.roseboy.jeee.admin.util.ConstUtils;
import net.roseboy.jeee.admin.util.DictUtils;
import net.roseboy.jeee.admin.util.MyBeanUtils;
import net.roseboy.jeee.admin.util.UserUtils;
import net.roseboy.jeee.core.common.BaseJeeeEntity;
import net.roseboy.jeee.core.common.BaseJeeeService;
import net.roseboy.jeee.core.common.Page;
import net.roseboy.jeee.core.util.DateUtils;
import net.roseboy.jeee.core.util.ExcelUtils;
import net.roseboy.jeee.core.util.ExceptionUtils;
import net.roseboy.jeee.core.util.ServletUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.subject.Subject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

@Service
@Transactional
public class BusiCcApplyService extends BaseJeeeService<BusiCcApplyDao, BusiCcApply> {
  @Autowired
  private AuditService auditService;
  
  @Autowired
  UserService userService;
  
  @Autowired
  private BusiCcApplyDetailService detilService;
  
  @Autowired
  private BusiExpenseCashierService cashierService;
  
  @Autowired
  private BillNoService billNoService;
  
  @Autowired
  private BusiEnclosureService busiEnclosureService;
  
  @Autowired
  private DepartService departService;
  
  @Autowired
  private RoleService roleService;
  
  @Autowired
  private DataProjectService dataProjectService;
  
  @Autowired
  private BudgetExecuteService budgetExecuteService;
  
  @Autowired
  private BudgetControlService budgetControlService;
  
  @Autowired
  private DataReimbursementService dataReimbursementService;
  
  @Autowired
  private DataProjectTypeService dataProjectTypeService;
  
  @Autowired
  private BusiCcReimburBudgetDetailService busiCcReimburBudgetDetailService;
  
  @Autowired
  private DataKeyanProjectService dataKeyanProjectService;
  
  @Autowired
  private BaseService baseService;
  
  @Autowired
  private DataAuditDetailRecordService dataAuditDetailRecordService;
  
  @Autowired
  private ActivitiService activitiService;
  
  private final Map<String, BiConsumer<Map<String, Object>, BusiCcApply>> commitByPrivateInprojectMap = new HashMap<>();
  
  @PostConstruct
  private void initFormAllMap() {
    this.commitByPrivateInprojectMap.put("erlonglu", this::privateErLongLuParameter);
  }
  
  public BusiCcApply get(String id) {
    BusiCcApply t = new BusiCcApply();
    t.setId(id);
    t = ((BusiCcApplyDao)this.dao).autoGet(t);
    t.setBudgetDetailList(this.busiCcReimburBudgetDetailService.getByExpenseId(id));
    t.setDetailList(this.detilService.getByRequistionId(id));
    t.setEnclosuresList(this.busiEnclosureService.getByExpenseId(id));
    return t;
  }
  
  public BusiCcApply get(BusiCcApply busiCcApply) {
    return ((BusiCcApplyDao)this.dao).autoGet(busiCcApply);
  }
  
  public Page<BusiCcApply> findPage(Page<BusiCcApply> page, BusiCcApply entity) {
    entity.setPage(page);
    List<BusiCcApply> list = ((BusiCcApplyDao)this.dao).autoQuery(entity);
    List<String> ids = new ArrayList<>();
    if (listIsNotNull(list)) {
      List<String> collect = (List<String>)list.stream().map(e -> e.getId()).collect(Collectors.toList());
      BusiCcReimburBudgetDetail bd = new BusiCcReimburBudgetDetail();
      bd.where("IN", "expenseId", collect);
      List<BusiCcReimburBudgetDetail> detailList = this.busiCcReimburBudgetDetailService.findList(bd);
      Map<String, List<BusiCcReimburBudgetDetail>> detailsMap = (Map<String, List<BusiCcReimburBudgetDetail>>)detailList.stream().collect(Collectors.groupingBy(e -> e.getExpenseId()));
      BusiCcApplyDetail bcd = new BusiCcApplyDetail();
      bd.where("IN", "mainId", collect);
      List<BusiCcApplyDetail> applyDetailList = this.detilService.findList(bcd);
      Map<String, List<BusiCcApplyDetail>> applyDtailsMap = (Map<String, List<BusiCcApplyDetail>>)applyDetailList.stream().collect(Collectors.groupingBy(e -> e.getMainId()));
      for (BusiCcApply busiCcApply : list) {
        ids.add(busiCcApply.getId());
        if (this.busiEnclosureService.getByExpenseId(busiCcApply.getId()) != null && this.busiEnclosureService.getByExpenseId(busiCcApply.getId()).size() > 0)
          busiCcApply.setHaveFile(true); 
        if (busiCcApply.getAudit().intValue() == -1) {
          String backMessage = ((BusiCcApplyDao)this.dao).queryBackContent(busiCcApply.getProcInsId());
          busiCcApply.setBackMessage(backMessage);
        } 
        List<BusiCcReimburBudgetDetail> busiExpenseDetails = detailsMap.get(busiCcApply.getId());
        if (listIsNotNull(busiExpenseDetails)) {
          String getProjectCode = busiExpenseDetails.stream().filter(e -> !StringUtils.isEmpty(e.getProjectCode())).map(e -> e.getProjectCode()).distinct().collect(Collectors.joining(","));
          busiCcApply.setProjectCode(getProjectCode);
        } 
        List<BusiCcApplyDetail> busiCcApplyDetails = applyDtailsMap.get(busiCcApply.getId());
        if (listIsNotNull(busiCcApplyDetails)) {
          String getProjectCode = busiCcApplyDetails.stream().filter(e -> !StringUtils.isEmpty(e.getOperatorId())).map(e -> e.getOperatorId()).distinct().collect(Collectors.joining(","));
          busiCcApply.setTravelId(getProjectCode);
        } 
      } 
    } 
    page.setList(list);
    return page;
  }
  
  public Page<BusiCcApply> autoQuery(Page<BusiCcApply> page, BusiCcApply entity) {
    entity.setPage(page);
    List<BusiCcApply> busiCcApplyList = ((BusiCcApplyDao)this.dao).autoQuery(entity);
    if (listIsNotNull(busiCcApplyList)) {
      List<String> collect = (List<String>)busiCcApplyList.stream().map(e -> e.getId()).collect(Collectors.toList());
      BusiCcReimburBudgetDetail bd = new BusiCcReimburBudgetDetail();
      bd.where("IN", "expenseId", collect);
      List<BusiCcReimburBudgetDetail> detailList = this.busiCcReimburBudgetDetailService.findList(bd);
      Map<String, List<BusiCcReimburBudgetDetail>> detailsMap = (Map<String, List<BusiCcReimburBudgetDetail>>)detailList.stream().collect(Collectors.groupingBy(e -> e.getExpenseId()));
      for (BusiCcApply vo : busiCcApplyList) {
        if (this.busiEnclosureService.getByExpenseId(vo.getId()) != null && this.busiEnclosureService.getByExpenseId(vo.getId()).size() > 0)
          vo.setHaveFile(true); 
        List<BusiCcReimburBudgetDetail> busiExpenseDetails = detailsMap.get(vo.getId());
        if (listIsNotNull(busiExpenseDetails)) {
          String getProjectCode = busiExpenseDetails.stream().filter(e -> !StringUtils.isEmpty(e.getProjectCode())).map(e -> e.getProjectCode()).distinct().collect(Collectors.joining(","));
          vo.setProjectCode(getProjectCode);
        } 
      } 
    } 
    page.setList(busiCcApplyList);
    return page;
  }
  
  public void save(BusiCcApply busiccaplly) {
    List<BusiCcApplyDetail> detailList = null;
    if (busiccaplly.getDetailList() != null)
      detailList = busiccaplly.getDetailList(); 
    List<BusiCcReimburBudgetDetail> budgetDetailList = null;
    if (busiccaplly.getBudgetDetailList() != null)
      budgetDetailList = busiccaplly.getBudgetDetailList(); 
    autoSave((BaseJeeeEntity)busiccaplly);
    this.busiCcReimburBudgetDetailService.save(busiccaplly.getId(), null, budgetDetailList);
    this.detilService.save(busiccaplly.getId(), null, detailList);
    List<BusiEnclosure> enclosuresList = null;
    if (busiccaplly.getEnclosuresList() != null)
      enclosuresList = busiccaplly.getEnclosuresList(); 
    this.busiEnclosureService.save(busiccaplly.getId(), null, enclosuresList);
  }
  
  public void saveList(List<BusiCcApply> list) {
    batchSave(list);
  }
  
  public void delete(String[] ids) {
    for (String id : ids) {
      ((BusiCcApplyDao)this.dao).deleteByTable("busi_cc_apply", "id", id);
      ((BusiCcApplyDao)this.dao).deleteByTable("busi_cc_apply_detail", "main_id", id);
      ((BusiCcApplyDao)this.dao).deleteByTable("busi_cc_reimbur_budget_detail", "expense_id", id);
      ((BusiCcApplyDao)this.dao).deleteByTable("busi_expense_cashier", "expense_id", id);
    } 
  }
  
  public List<BusiCcApply> findList(BusiCcApply t) {
    return ((BusiCcApplyDao)this.dao).autoQuery(t);
  }
  
  @Transactional(readOnly = false)
  public void audit(BusiCcApply entity, String pass, String comment) {
    String taskKey = this.auditService.getCurrentTaskKey(entity.getProcInsId());
    if ("yes".equals(pass)) {
      try {
        String detailNames = getPara("detailNames", "");
        if (isNotEmpty(detailNames))
          this.dataAuditDetailRecordService.saveAuditDetailNames(entity.getId(), entity.getProcInsId(), detailNames); 
      } catch (Exception exception) {}
      if ("erlonglu".equals(ConstUtils.getValue("systemName"))) {
        this.auditService.aignAuditAgreeKeyanInter(entity, comment, null, "busi_cc_apply", null, null);
      } else {
        this.auditService.aignAuditAgree(entity, comment, null);
      } 
    } else if ("no".equals(pass)) {
      this.auditService.auditBack(entity, comment, null);
    } else if ("revoke".equals(pass)) {
      List<Map<String, String>> procInsInfoList = new ArrayList<>();
      if (null != entity && isNotEmpty(entity.getProcInsId()))
        procInsInfoList = this.activitiService.getHisProcInsInfoList(entity.getProcInsId()); 
      this.auditService.auditCancelSign(entity);
      this.dataAuditDetailRecordService.removeAuditDetailRecord(entity.getId(), UserUtils.getUser().getId(), procInsInfoList);
      BusiCcApply entityBusi = get(entity.getId());
      if (isNotEmpty(entityBusi.getProcInsId())) {
        String nextAudtRoleEnd = this.auditService.getNextAudtRoleEnd(entity.getProcInsId());
        if ("财务处长".equals(nextAudtRoleEnd))
          edit(entityBusi.getId(), "audit", Integer.valueOf(3)); 
      } 
    } else if ("annex".equals(pass)) {
      String backFlag = "";
      String nextAudtRoleEnd = this.auditService.getNextAudtRoleEnd(entity.getProcInsId());
      if ("事前审核".equals(nextAudtRoleEnd)) {
        backFlag = "2";
      } else if ("财务处长".equals(nextAudtRoleEnd) || "财务主管".equals(nextAudtRoleEnd)) {
        backFlag = "3";
      } else if ("库管".equals(nextAudtRoleEnd)) {
        backFlag = "4";
      } 
      if (isEmpty(backFlag))
        backFlag = "1"; 
      this.auditService.auditAnnexFileBackYA(entity, comment, "[退回补充附件]", null, backFlag);
      this.budgetExecuteService.deleteBudgetExecute(entity.getId(), null);
    } 
    if ("".equals(taskKey));
  }
  
  @Transactional(readOnly = false)
  public void commit(BusiCcApply entity) {
    String isOpenApplyBudget = ConstUtils.getValue("isOpenApplyBudget", "0");
    if ("1".equals(isOpenApplyBudget))
      genBudgetExecute(entity, OperateEntity.EXECUTETYPE_OCCUPY); 
    String systemName = ConstUtils.getValue("systemName");
    Map<String, Object> vars = new HashMap<>();
    List<BusiCcReimburBudgetDetail> detailList = entity.getBudgetDetailList();
    String projectCodeEntity = "";
    DataProject dataProject = null;
    if (listIsNotNull(detailList)) {
      dataProject = this.dataProjectService.getByCode(((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode());
      if (dataProject != null) {
        String libraryTubeAudit = dataProject.getLibraryTubeAudit();
        if (StringUtils.isEmpty(libraryTubeAudit)) {
          vars.put("isLib", "0");
        } else {
          vars.put("isLib", "1");
          vars.put("leaderUser", libraryTubeAudit);
        } 
      } 
      if (dataProject != null) {
        String projectDeanId = dataProject.getProjectDeanId();
        if (!StringUtils.isEmpty(projectDeanId)) {
          vars.put("userByAssign", projectDeanId);
        } else {
          List<String> roles = new ArrayList<>();
          roles.add("0003");
          List<String> userNameByDepartRoleCharge = this.auditService.getUserNameByDepartRoleCharge(roles, dataProject.getProjectDepartId());
          String userByAssign = userNameByDepartRoleCharge.stream().collect(Collectors.joining(","));
          vars.put("userByAssign", userByAssign);
        } 
        if (!StringUtils.isEmpty(dataProject.getAccountingBudgetId())) {
          vars.put("deanUserIds", dataProject.getAccountingBudgetId());
        } else {
          List<String> roles = new ArrayList<>();
          roles.add("0006");
          List<String> userNameByRole = this.auditService.getUserNameByRole(roles);
          String deanUserIds = userNameByRole.stream().collect(Collectors.joining(","));
          vars.put("deanUserIds", deanUserIds);
        } 
        vars.put("approvalDepart", dataProject.getProjectDepartId());
      } else if (!systemName.equals("erlonglu") && !systemName.equals("shtongji")) {
        ExceptionUtils.throwProjectException(((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode() + "此项目档案不存在");
      } 
      if ("shtongji".equals(systemName))
        if ("7".equals(entity.getBudgetSources())) {
          DataKeyanProject dataKeyanProject = this.dataKeyanProjectService.getByCode(((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode());
          vars.put("submitBillUserIds", dataKeyanProject.getProjectRespoId());
          vars.put("userByAssign", dataKeyanProject.getAccountingBudgetId());
          vars.put("focusedDepart", dataKeyanProject.getGuiKouDepartId());
          vars.put("auditFocusedDepart", dataKeyanProject.getGuiKouDepartId());
        } else if (dataProject != null) {
          vars.put("userByAssign", dataProject.getAccountingBudgetId());
          vars.put("focusedDepart", dataProject.getProjectDepartId());
        }  
      projectCodeEntity = ((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode();
      vars.put("projectCode", ((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode());
    } 
    vars.put("audit", entity.getAudit());
    vars.put("isNeedLeader", "0");
    List<BusiCcApplyDetail> detailList1 = entity.getDetailList();
    String roleStr = DictUtils.getName("dict_busicc_page_name", "isNeedLeaderForRoles");
    if (listIsNotNull(detailList1) && isNotEmpty(roleStr))
      for (BusiCcApplyDetail busiCcApplyDetail : detailList1) {
        String sql = "select role from sys_role sr left join sys_user_role sur on sr.id=sur.role_id left join sys_user su on su.id=sur.user_id left join data_staff ds on su.username=ds.job_num where ds.id=?";
        List<Map<String, Object>> userServiceListBySql = this.userService.findListBySql(sql, new Object[] { busiCcApplyDetail.getOperatorId() });
        if (listIsNotNull(userServiceListBySql)) {
          String roleCode = (String)((Map)userServiceListBySql.get(0)).get("role");
          String[] split = roleStr.split(",");
          for (String s : split) {
            if (s.equals(roleCode)) {
              vars.put("isNeedLeader", "1");
              // Byte code: goto -> 808
            } 
          } 
        } 
      }  
    BiConsumer<Map<String, Object>, BusiCcApply> systemNameBiConsumer = this.commitByPrivateInprojectMap.get(systemName);
    if (!StringUtils.isEmpty(systemNameBiConsumer))
      systemNameBiConsumer.accept(vars, entity); 
    if ("0".equals(entity.getCcType())) {
      if (systemName.equals("cpjingbaoyuan")) {
        vars.put("module", "公务出差申请单");
      } else {
        vars.put("module", "出差申请单");
      } 
      vars.put("isBackAnnex", "0");
      vars.put("amount", "1");
      vars.put("money", entity.getSumMoney());
      if (!StringUtils.isEmpty(entity.getSumMoney()) && entity.getSumMoney().compareTo(new BigDecimal("2000")) >= 0)
        vars.put("amount", "2"); 
      vars.put("operator", this.userService.get(entity.getOperator()).getRealname());
      if (dataProject != null)
        vars.put("projectCode", dataProject.getCode()); 
      vars.put("date", entity.getBillDate());
      vars.put("budgetSources", entity.getBudgetSources());
      vars.put("type", "CC");
      vars.put("code", entity.getCode());
      vars.put("uses", entity.getTravelCause());
      vars.put("isCar", entity.getIsCar());
      vars.put("busiCcType", entity.getBusiCcType());
      if (systemName.equals("erlonglu")) {
        if ("7".equals(entity.getBudgetSources()) || "6".equals(entity.getBudgetSources()) || "5".equals(entity.getBudgetSources()) || "2".equals(entity.getBudgetSources())) {
          DataKeyanProject dataKeyanProject = this.dataKeyanProjectService.getByCode(((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode());
          vars.put("submitBillUserIds", dataKeyanProject.getProjectRespoId());
          vars.put("userByAssign", dataKeyanProject.getAccountingBudgetId());
        } else {
          vars.put("userByAssign", dataProject.getAccountingBudgetId());
        } 
      } else if ("7".equals(entity.getBudgetSources())) {
        DataKeyanProject dataKeyanProject = this.dataKeyanProjectService.getByCode(((BusiCcReimburBudgetDetail)detailList.get(0)).getProjectCode());
        vars.put("submitBillUserIds", dataKeyanProject.getProjectRespoId());
        vars.put("userByAssign", dataKeyanProject.getAccountingBudgetId());
        if ("yyzhongxin".equals(ConstUtils.getValue("systemName")))
          vars.put("focusedDepart", dataKeyanProject.getGuiKouDepartId()); 
      } else {
        vars.put("userByAssign", dataProject.getAccountingBudgetId());
        if ("yyzhongxin".equals(ConstUtils.getValue("systemName")))
          vars.put("focusedDepart", dataProject.getProjectDepartId()); 
      } 
      if (systemName.equals("erlonglu")) {
        if (!"7".equals(entity.getBudgetSources()) && !"6".equals(entity.getBudgetSources()) && !"5".equals(entity.getBudgetSources()) && !"2".equals(entity.getBudgetSources())) {
          StringBuffer oaContent = new StringBuffer("部门：" + this.departService.get(entity.getDepartId()).getName() + " -- 经办人：" + this.userService.get(entity.getOperator()).getRealname() + " -- 出差事由：" + entity.getTravelCause() + " -- 预算项目：" + DictUtils.getName("dict_project", dataProject.getCode()) + " -- 预计总费用： " + entity.getSumMoney() + " -- 资金来源：" + DictUtils.getName("dict_budget_sources", entity.getBudgetSources()));
          List<BusiCcApplyDetail> busiCcApplyDetailList = this.detilService.getByRequistionId(entity.getId());
          for (BusiCcApplyDetail busiCcApplyDetail : busiCcApplyDetailList)
            oaContent.append(" -- 出差人：" + DictUtils.getName("dict_staff", busiCcApplyDetail.getOperatorId()) + " -- 起始时间：" + busiCcApplyDetail
                .getBeginDate() + " -- 结束时间：" + busiCcApplyDetail.getEndDate() + " -- 到达地点：" + DictUtils.getName("dict_data_travel", busiCcApplyDetail.getToAddress())); 
          vars.put("oAContent", oaContent);
        } 
      } else {
        StringBuffer oaContent = new StringBuffer("部门：" + this.departService.get(entity.getDepartId()).getName() + " -- 经办人：" + this.userService.get(entity.getOperator()).getRealname() + " -- 出差事由：" + entity.getTravelCause() + " -- 预算项目：" + DictUtils.getName("dict_project", projectCodeEntity) + " -- 预计总费用： " + entity.getSumMoney() + " -- 资金来源：" + DictUtils.getName("dict_budget_sources", entity.getBudgetSources()));
        List<BusiCcApplyDetail> busiCcApplyDetailList = this.detilService.getByRequistionId(entity.getId());
        for (BusiCcApplyDetail busiCcApplyDetail : busiCcApplyDetailList)
          oaContent.append(" -- 出差人：" + DictUtils.getName("dict_staff", busiCcApplyDetail.getOperatorId()) + " -- 起始时间：" + busiCcApplyDetail
              .getBeginDate() + " -- 结束时间：" + busiCcApplyDetail.getEndDate() + " -- 到达地点：" + DictUtils.getName("dict_data_travel", busiCcApplyDetail.getToAddress())); 
        vars.put("oAContent", oaContent);
      } 
      if ("erlonglu".equals(systemName)) {
        String relevantDepartName = entity.getRelevantDepartId();
        String dict_depart = DictUtils.getName("dict_depart", relevantDepartName);
        if (dict_depart.equals("科教科")) {
          vars.put("relevantDepartName", "1");
        } else if (dict_depart.equals("党委办公室")) {
          vars.put("relevantDepartName", "2");
        } else {
          vars.put("relevantDepartName", "0");
        } 
        vars.put("focusedDepart", relevantDepartName);
      } 
      vars.put("startDate", DateUtils.parseDate(new Date(), "yyyy-MM-dd HH:mm"));
      vars.put("departName", this.departService.get(entity.getDepartId()).getName());
      if ("1".equals(entity.getBudgetSources())) {
        vars.put("sourcesType", "1");
      } else {
        vars.put("sourcesType", "2");
        if (dataProject != null)
          vars.put("billSubmitUserIds", dataProject.getResponsiblePersonId()); 
      } 
      vars.put("personLevel", UserUtils.getAuthInfo().getRoles().contains("0001") ? "1" : "0");
      if (-4 == entity.getAudit().intValue())
        vars.put("isBackAnnex", "1"); 
      vars.put("goKeShi", "1");
      if ("1".equals(entity.getBudgetSources()) || "2".equals(entity.getBudgetSources()) || "5"
        .equals(entity.getBudgetSources()) || "7".equals(entity.getBudgetSources()) || "8".equals(entity.getBudgetSources())) {
        vars.put("goKeShi", "0");
        List<String> codes = (List<String>)detailList.stream().filter(e -> isNotEmpty(e.getProjectCode())).map(BusiCcReimburBudgetDetail::getProjectCode).distinct().collect(Collectors.toList());
        DataProject project = new DataProject();
        project.where("IN", "code", codes);
        if (dataProject != null) {
          List<DataProject> projectList = this.dataProjectService.findList(dataProject);
          String billSubmitUserIds = projectList.stream().filter(e -> isNotEmpty(e.getResponsiblePersonId())).map(DataProject::getResponsiblePersonId).collect(Collectors.joining(","));
          vars.put("billSubmitUserIds", billSubmitUserIds);
        } 
      } 
      if (systemName.equals("cpjingbaoyuan")) {
        this.auditService.commit(entity, "[公务出差申请单]", vars, "ccsqd");
      } else {
        if ("yyzhongxin".equals(systemName)) {
          vars.put("station", entity.getStation());
          vars.put("isHospitalOffice", "0");
          List<String> departCodes = Lists.newArrayList(new String[] { "100" });
          Depart depart = this.departService.get(entity.getDepartId());
          if (StringUtils.isNotBlank(depart.getCode()) && departCodes.contains(depart.getCode()))
            vars.put("isHospitalOffice", "1"); 
        } 
        this.auditService.commit(entity, "[出差申请单]", vars, "ccsqd");
      } 
    } else {
      vars.put("module", "出国申请单");
      if ("erlonglu".equals(systemName) || "shtongji".equals(systemName)) {
        List<BusiCcReimburBudgetDetail> budgetDetailList = entity.getBudgetDetailList();
        for (BusiCcReimburBudgetDetail busiCcReimburBudgetDetail : budgetDetailList) {
          String projectCode = busiCcReimburBudgetDetail.getProjectCode();
          DataKeyanProject byCode = this.dataKeyanProjectService.getByCode(projectCode);
          if (byCode != null) {
            String str1 = byCode.getGuiKouDepartId();
            String str2 = DictUtils.getName("dict_depart", str1);
            if (str2.equals("科教科")) {
              vars.put("relevantDepartName", "1");
            } else if (str2.equals("党委办公室")) {
              vars.put("relevantDepartName", "2");
            } else {
              vars.put("relevantDepartName", "0");
            } 
            vars.put("focusedDepart", str1);
            continue;
          } 
          DataProject byCode1 = this.dataProjectService.getByCode(projectCode);
          String guiKouDepartId = byCode1.getProjectDepartId();
          String dict_depart = DictUtils.getName("dict_depart", guiKouDepartId);
          if (dict_depart.equals("科教科")) {
            vars.put("relevantDepartName", "1");
          } else if (dict_depart.equals("党委办公室")) {
            vars.put("relevantDepartName", "2");
          } else {
            vars.put("relevantDepartName", "0");
          } 
          vars.put("focusedDepart", guiKouDepartId);
        } 
      } 
      vars.put("isBackAnnex", "0");
      vars.put("amount", "1");
      vars.put("money", entity.getSumMoney());
      if (!StringUtils.isEmpty(entity.getSumMoney()) && entity.getSumMoney().compareTo(new BigDecimal("2000")) >= 0)
        vars.put("amount", "2"); 
      vars.put("operator", this.userService.get(entity.getOperator()).getRealname());
      vars.put("date", entity.getBillDate());
      vars.put("type", "AA");
      if (dataProject != null)
        vars.put("projectCode", dataProject.getCode()); 
      vars.put("code", entity.getCode());
      vars.put("uses", entity.getTravelCause());
      vars.put("departName", this.departService.get(entity.getDepartId()).getName());
      vars.put("budgetSources", entity.getBudgetSources());
      if ("1".equals(entity.getBudgetSources())) {
        vars.put("sourcesType", "1");
      } else {
        vars.put("sourcesType", "2");
        if (dataProject != null)
          vars.put("billSubmitUserIds", dataProject.getResponsiblePersonId()); 
      } 
      if ("erlonglu".equals(systemName)) {
        if (!"7".equals(entity.getBudgetSources()) && !"6".equals(entity.getBudgetSources()) && !"5".equals(entity.getBudgetSources()) && !"2".equals(entity.getBudgetSources())) {
          StringBuffer oaContent = new StringBuffer("部门：" + this.departService.get(entity.getDepartId()).getName() + " -- 经办人：" + this.userService.get(entity.getOperator()).getRealname() + " -- 出差事由：" + entity.getTravelCause() + " -- 预算项目：" + DictUtils.getName("dict_project", dataProject.getCode()) + " -- 预计总费用： " + entity.getSumMoney() + " -- 资金来源：" + DictUtils.getName("dict_budget_sources", entity.getBudgetSources()));
          List<BusiCcApplyDetail> busiCcApplyDetailList = this.detilService.getByRequistionId(entity.getId());
          for (BusiCcApplyDetail busiCcApplyDetail : busiCcApplyDetailList)
            oaContent.append(" -- 出差人：" + DictUtils.getName("dict_staff", busiCcApplyDetail.getOperatorId()) + " -- 起始时间：" + busiCcApplyDetail
                .getBeginDate() + " -- 结束时间：" + busiCcApplyDetail.getEndDate() + " -- 到达地点：" + DictUtils.getName("dict_data_travel", busiCcApplyDetail.getToAddress())); 
          vars.put("oAContent", oaContent);
        } 
      } else {
        StringBuffer oaContent = new StringBuffer("部门：" + this.departService.get(entity.getDepartId()).getName() + " -- 经办人：" + this.userService.get(entity.getOperator()).getRealname() + " -- 出差事由：" + entity.getTravelCause() + " -- 预算项目：" + DictUtils.getName("dict_project", projectCodeEntity) + " -- 预计总费用： " + entity.getSumMoney() + " -- 资金来源：" + DictUtils.getName("dict_budget_sources", entity.getBudgetSources()));
        List<BusiCcApplyDetail> busiCcApplyDetailList = this.detilService.getByRequistionId(entity.getId());
        for (BusiCcApplyDetail busiCcApplyDetail : busiCcApplyDetailList)
          oaContent.append(" -- 出差人：" + DictUtils.getName("dict_staff", busiCcApplyDetail.getOperatorId()) + " -- 起始时间：" + busiCcApplyDetail
              .getBeginDate() + " -- 结束时间：" + busiCcApplyDetail.getEndDate() + " -- 到达地点：" + DictUtils.getName("dict_data_travel", busiCcApplyDetail.getToAddress())); 
        vars.put("oAContent", oaContent);
      } 
      vars.put("startDate", DateUtils.parseDate(new Date(), "yyyy-MM-dd HH:mm"));
      if (-4 == entity.getAudit().intValue())
        vars.put("isBackAnnex", "1"); 
      vars.put("goKeShi", "1");
      if ("1".equals(entity.getBudgetSources()) || "2".equals(entity.getBudgetSources()) || "5"
        .equals(entity.getBudgetSources()) || "7".equals(entity.getBudgetSources()) || "8".equals(entity.getBudgetSources())) {
        vars.put("goKeShi", "0");
        List<String> codes = (List<String>)detailList.stream().filter(e -> isNotEmpty(e.getProjectCode())).map(BusiCcReimburBudgetDetail::getProjectCode).distinct().collect(Collectors.toList());
        DataProject project = new DataProject();
        project.where("IN", "code", codes);
        if (dataProject != null) {
          List<DataProject> projectList = this.dataProjectService.findList(dataProject);
          String billSubmitUserIds = projectList.stream().filter(e -> isNotEmpty(e.getResponsiblePersonId())).map(DataProject::getResponsiblePersonId).collect(Collectors.joining(","));
          vars.put("billSubmitUserIds", billSubmitUserIds);
        } 
      } 
      if ("shtongji".equals(systemName)) {
        this.auditService.commit(entity, "[出国申请单]", vars, "AA");
      } else {
        this.auditService.commit(entity, "[出国申请单]", vars, "ccsqd");
      } 
    } 
  }
  
  public void genBudgetExecute(BusiCcApply entity, String executeType) {
    List<BusiCcReimburBudgetDetail> detailList = this.busiCcReimburBudgetDetailService.getByExpenseId(entity.getId());
    String budgetSources = entity.getBudgetSources();
    String generalOrScientific = !"7".equals(budgetSources) ? "0" : "1";
    String systemName = ConstUtils.getValue("systemName");
    if ("erlonglu".equals(systemName))
      generalOrScientific = ("2".equals(budgetSources) || "5".equals(budgetSources) || "6".equals(budgetSources) || "7".equals(budgetSources)) ? "1" : "0"; 
    List<Map<String, Object>> executePipelineLists = new ArrayList<>();
    String billType = "";
    if ("0".equals(entity.getCcType())) {
      billType = "CC";
    } else {
      billType = "AA";
    } 
    String contractId = "";
    String loanNoteId = "";
    BigDecimal loanNoteMoney = null;
    for (BusiCcReimburBudgetDetail detail : detailList) {
      Map<String, Object> map = new HashMap<>();
      map.put("money", detail.getExpenseMoney().negate());
      map.put("budgetSubjectCode", detail.getBudgetProjectCode());
      map.put("projectCode", detail.getProjectCode());
      map.put("executeType", executeType);
      map.put("executeYear", entity.getBudgetYear());
      map.put("departId", entity.getDepartId());
      map.put("billId", entity.getId());
      map.put("billDetailId", detail.getId());
      map.put("billType", billType);
      map.put("instId", entity.getInstId());
      map.put("contractId", contractId);
      map.put("requistionId", loanNoteId);
      map.put("isPay", StringUtils.isEmpty(entity.getIsPay()) ? "0" : entity.getIsPay());
      map.put("pperatorDepartId", entity.getDepartId());
      try {
        Subject subject = SecurityUtils.getSubject();
        User principal = (User)subject.getPrincipal();
        map.put("operator", principal.getId());
      } catch (Exception e) {
        this.logger.error("======占用预算的方法genBudgetExecute()出现异常，异常原因为：{}=========", e.getMessage());
      } 
      executePipelineLists.add(map);
    } 
    OperateEntity build = OperateEntity.builder().mainId(entity.getId()).generalOrScientific(generalOrScientific).executeType(executeType).contractId(contractId).loanNoteId(loanNoteId).loanNoteMoney(loanNoteMoney).executePipelineLists(executePipelineLists).build();
    this.applicationContext.publishEvent(build);
  }
  
  public void billCopy(String[] ids) {
    for (String id : ids) {
      BusiCcApply entity = get(id);
      BusiCcApply newEntity = getNewEntity(entity);
      newEntity.setProcInsId("");
      save(newEntity);
    } 
  }
  
  public BusiCcApply getNewEntity(BusiCcApply oldEntity) {
    BusiCcApply newEntity = new BusiCcApply();
    try {
      List<BusiCcApplyDetail> detailList = oldEntity.getDetailList();
      List<BusiCcReimburBudgetDetail> budgetDetailList = oldEntity.getBudgetDetailList();
      List<BusiCcApplyDetail> newDetailList = new ArrayList<>();
      List<BusiCcReimburBudgetDetail> newBudgetDetailList = new ArrayList<>();
      MyBeanUtils.copyBeanNotNull2Bean(oldEntity, newEntity);
      newEntity.setId(null);
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy");
      SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd");
      if ("0".equals(oldEntity.getCcType())) {
        if ("cpjingbaoyuan".equals(ConstUtils.getValue("systemName"))) {
          newEntity.setCode(this.billNoService.makeBillNo("CCJK"));
        } else {
          newEntity.setCode(this.billNoService.makeBillNo("CC"));
        } 
      } else {
        newEntity.setCode(this.billNoService.makeBillNo("AA"));
      } 
      newEntity.setAudit(Integer.valueOf(-2));
      newEntity.setBillDate(sf.format(new Date()));
      newEntity.setBudgetYear(sdf.format(new Date()));
      newEntity.setSumMoney(null);
      newEntity.setIsPay(Integer.valueOf(0));
      if (detailList.size() > 0)
        for (BusiCcApplyDetail detail : detailList) {
          BusiCcApplyDetail newDetail = new BusiCcApplyDetail();
          MyBeanUtils.copyBeanNotNull2Bean(detail, newDetail);
          newDetail.setId(null);
          newDetail.setMainId(null);
          newDetail.setAccomCost(null);
          newDetail.setMealsCost(null);
          newDetail.setTrafficCost(null);
          newDetail.setTransportCost(null);
          newDetail.setOtherCost(null);
          newDetail.setTotalCost(null);
          newDetailList.add(newDetail);
        }  
      if (detailList.size() > 0)
        for (BusiCcReimburBudgetDetail detail : budgetDetailList) {
          BusiCcReimburBudgetDetail newDetail = new BusiCcReimburBudgetDetail();
          MyBeanUtils.copyBeanNotNull2Bean(detail, newDetail);
          BigDecimal subjectBalance = budgetAccountBalance(newDetail.getProjectCode(), newEntity.getBudgetYear(), newDetail
              .getDepartId(), newDetail.getBudgetProjectCode());
          newDetail.setSubjectBalance(subjectBalance);
          newDetail.setId(null);
          newDetail.setExpenseMoney(null);
          newDetail.setExpenseId(null);
          newBudgetDetailList.add(newDetail);
        }  
      newEntity.setDetailList(newDetailList);
      newEntity.setBudgetDetailList(newBudgetDetailList);
      newEntity.setEnclosuresList(null);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return newEntity;
  }
  
  private BigDecimal budgetAccountBalance(String projectCode, String year, String departId, String budgetProjectCode) {
    BigDecimal subjectBalance = BigDecimal.ZERO;
    BudgetControl budgetControlByCodeAndYear = this.budgetControlService.getBudgetControlByCodeAndYear(projectCode, year);
    if (null != budgetControlByCodeAndYear)
      if (2 == budgetControlByCodeAndYear.getControlType().intValue()) {
        subjectBalance = this.budgetExecuteService.getBudgetAccountBalance(projectCode, year, budgetProjectCode);
      } else if (1 == budgetControlByCodeAndYear.getControlType().intValue()) {
        subjectBalance = this.budgetExecuteService.getBudgetAccountBalanceByProject(projectCode, year);
      } else if (3 == budgetControlByCodeAndYear.getControlType().intValue()) {
        subjectBalance = this.budgetExecuteService.getBudgetAccountBalanceByDepart(departId, year);
      } else if (6 == budgetControlByCodeAndYear.getControlType().intValue()) {
        subjectBalance = this.budgetExecuteService.getBudgetAccountBalanceByDepartAndProject(departId, projectCode);
      }  
    return subjectBalance;
  }
  
  public void invalid(String id) {
    if (StringUtils.isEmpty(id))
      ExceptionUtils.throwProjectException("id不能为空"); 
    BusiCcApply busiExpense = get(id);
    if (busiExpense == null)
      throw new IllegalArgumentException("出差申请单不存在"); 
    if (busiExpense.getAudit().intValue() != 4)
      throw new IllegalArgumentException("审批状态完成后才可以进行此操作"); 
    if (busiExpense.getIsPay().intValue() == 1)
      throw new IllegalArgumentException("出纳已付款的单据不允许作废"); 
    busiExpense.setAudit(Integer.valueOf(8));
    this.budgetExecuteService.deleteBudgetExecute(busiExpense.getId(), null);
    save(busiExpense);
  }
  
  private String saveBudgetExecute(BusiCcApply entity) {
    try {
      BudgetExecute be = new BudgetExecute();
      be.setExecuteType(BudgetExecute.EXECUTETYPE_REIM);
      be.setExecuteYear(entity.getBudgetYear());
      Depart depart = this.departService.get(entity.getDepartId());
      if (depart != null) {
        be.setDepartId(depart.getBudgetDepartId());
      } else {
        ExceptionUtils.throwProjectException("当前经办部门的预算申报部门不存在！");
      } 
      be.setOperatorDepartId(entity.getDepartId());
      be.setBillId(entity.getId());
      be.setProjectCode(entity.getProjectCode());
      be.setBillType("CC");
      be.setMoney(entity.getSumMoney().negate());
      String reimCode = entity.getDatareimbursementCode();
      String budgetProjectCode = "";
      if (!StringUtils.isEmpty(reimCode)) {
        List<DataReimbursement> dataReimbursements = this.dataReimbursementService.getByCode(reimCode);
        if (dataReimbursements != null && dataReimbursements.size() > 0)
          budgetProjectCode = ((DataReimbursement)dataReimbursements.get(0)).getBudgetProjectCode(); 
      } 
      be.setBudgetSubjectCode(budgetProjectCode);
      this.budgetExecuteService.save(be);
    } catch (Exception e) {
      return e.getMessage();
    } 
    return null;
  }
  
  public Map<String, Object> isExceed(BusiCcApply entity) {
    List<String> budgetProjectList = new ArrayList<>();
    List<BigDecimal> moneyList = new ArrayList<>();
    String departId = entity.getDepartId();
    String projectCode = ((BusiCcReimburBudgetDetail)entity.getBudgetDetailList().get(0)).getProjectCode();
    String year = entity.getBudgetYear();
    BigDecimal money = entity.getSumMoney();
    String reimCode = entity.getDatareimbursementCode();
    String budgetProjectCode = "";
    if (!StringUtils.isEmpty(reimCode)) {
      List<DataReimbursement> dataReimbursements = this.dataReimbursementService.getByCode(reimCode);
      if (dataReimbursements != null && dataReimbursements.size() > 0)
        budgetProjectCode = ((DataReimbursement)dataReimbursements.get(0)).getBudgetProjectCode(); 
    } 
    budgetProjectList.add(budgetProjectCode);
    moneyList.add(entity.getSumMoney());
    Map<String, Object> messageMap = this.budgetControlService.isExceed(projectCode, money, moneyList, budgetProjectList, departId, year, new ArrayList(), "0");
    return messageMap;
  }
  
  public List<Map<String, Object>> isExceed2(BusiCcApply entity) {
    List<Map<String, Object>> messageMap = new ArrayList<>();
    List<BusiCcReimburBudgetDetail> detailList = entity.getBudgetDetailList();
    String departId = entity.getDepartId();
    String year = entity.getBudgetYear();
    List<String> codes = (List<String>)detailList.stream().map(BusiCcReimburBudgetDetail::getProjectCode).distinct().collect(Collectors.toList());
    for (String projectCode : codes) {
      BigDecimal money = BigDecimal.ZERO;
      List<String> budgetProjectList = new ArrayList<>();
      List<BigDecimal> moneyList = new ArrayList<>();
      for (BusiCcReimburBudgetDetail detail : detailList) {
        if (isNotEmpty(projectCode) && projectCode.equals(detail.getProjectCode())) {
          budgetProjectList.add(detail.getBudgetProjectCode());
          moneyList.add(detail.getExpenseMoney());
          money = money.add(detail.getExpenseMoney());
        } 
      } 
      Map<String, Object> messageMapTmp = this.budgetControlService.isExceed(projectCode, money, moneyList, budgetProjectList, departId, year, new ArrayList(), "0");
      messageMap.add(messageMapTmp);
    } 
    return messageMap;
  }
  
  public void auditUndo(BusiCcApply entity) {
    this.budgetExecuteService.deleteBudgetExecute(entity.getId(), null);
    this.auditService.cancellationSubmission(entity);
  }
  
  public BusiCcApply getByCode(String code) {
    return ((BusiCcApplyDao)this.dao).getByCode(code);
  }
  
  public void releaseSelectedApply(BusiCcReimbur busiCcReimbur) {
    if (busiCcReimbur.getCcApplyId() != null && !busiCcReimbur.getCcApplyId().equals("")) {
      BusiCcApply entity = new BusiCcApply();
      entity.setCode(busiCcReimbur.getCcApplyId());
      List<BusiCcApply> busiCcApplies = findList(entity);
      for (BusiCcApply busiCcApply : busiCcApplies)
        this.auditService.updateState("busi_cc_apply", "is_select", "0", busiCcApply.getId()); 
    } 
  }
  
  public Boolean chekckNextAuditCaiwu(BusiCcApply e) {
    Boolean b = Boolean.valueOf(false);
    if (!StringUtils.isEmpty(e.getAudit()) && !StringUtils.isEmpty(e.getId()) && e.getAudit().intValue() == 3) {
      String nextUserById = this.auditService.findNextUserById(e.getId());
      User user = UserUtils.getUser();
      if (nextUserById.contains(user.getUsername()))
        b = Boolean.valueOf(true); 
    } 
    return b;
  }
  
  public void export(BusiCcApply busiCcApply, HttpServletRequest request, HttpServletResponse response) throws FileNotFoundException {
    busiCcApply = getExportData(busiCcApply, request);
    String ids = request.getParameter("ids");
    if (StringUtils.isNotBlank(ids))
      busiCcApply.where("IN", "id", ids.split(",")); 
    List<BusiCcApply> list = findList(busiCcApply);
    list = formatList(list);
    if (listIsNotNull(list)) {
      List<String> collect = (List<String>)list.stream().map(e -> e.getId()).collect(Collectors.toList());
      collect.add("---------------");
      BusiCcReimburBudgetDetail detail = new BusiCcReimburBudgetDetail();
      detail.where("IN", "expenseId", collect);
      List<BusiCcReimburBudgetDetail> budgetDetails = this.busiCcReimburBudgetDetailService.findList(detail);
      Map<String, List<BusiCcReimburBudgetDetail>> listMap = (Map<String, List<BusiCcReimburBudgetDetail>>)budgetDetails.stream().collect(Collectors.groupingBy(e -> e.getExpenseId()));
      for (BusiCcApply ccApply : list) {
        List<BusiCcReimburBudgetDetail> detailList = listMap.get(ccApply.getId());
        if (listIsNotNull(detailList)) {
          String projectCode = detailList.stream().filter(e -> !StringUtils.isEmpty(e.getProjectCode())).map(e -> e.getProjectCode()).distinct().collect(Collectors.joining(","));
          String projectName = detailList.stream().filter(e -> !StringUtils.isEmpty(e.getProjectCode())).map(e -> DictUtils.getName("dict_project", e.getProjectCode(), "")).distinct().collect(Collectors.joining(","));
          ccApply.setProjectCode(projectCode);
          ccApply.setProjectName(projectName);
        } 
      } 
    } 
    List<String> nameSR = Lists.newArrayList(new String[] { "审批状态", "单据编号", "单据日期", "经办人", "经办人部门", "出差事由", "预算项目号", "预算项目名称", "预算总费用", "特殊事项说明" });
    List<String> filedListSR = Lists.newArrayList(new String[] { "auditName", "code", "billDate", "operatorName", "departName", "travelCause", "projectCode", "projectName", "sumMoney", "memo" });
    String ccType = getPara("ccType");
    String downTitleName = "出差申请单";
    if ("1".equals(ccType))
      downTitleName = "出国申请单"; 
    File xlsFileSR = ExcelUtils.exportXls(downTitleName, nameSR, filedListSR, list, null);
    ServletUtils.download(request, response, new FileInputStream(xlsFileSR), downTitleName + ".xls");
  }
  
  public List<BusiCcApply> formatList(List<BusiCcApply> list) {
    for (BusiCcApply entity : list) {
      String name = DictUtils.getNames("dict_user", (entity.getOperator() == null) ? "" : entity.getOperator().toString(), "");
      String departName = DictUtils.getNames("dict_depart", (entity.getDepartId() == null) ? "" : entity.getDepartId().toString(), "");
      String audit = DictUtils.getName("dict_audit_state", (entity.getAudit().toString() == null) ? "" : entity.getAudit().toString(), "");
      entity.setDepartName(departName);
      entity.setOperatorName(name);
      entity.setAuditName(audit);
    } 
    return list;
  }
  
  public BusiCcApply setQueryCondition(BusiCcApply busiCcApply, HttpServletRequest request) {
    if ("0".equals(request.getParameter("ccType"))) {
      busiCcApply.setCcType("0");
    } else {
      busiCcApply.setCcType("1");
    } 
    String projectCode = request.getParameter("projectCode");
    String projectName = request.getParameter("projectName");
    if (!StringUtils.isEmpty(projectCode)) {
      busiCcApply.leftJoinWhere("LEFT JOIN busi_cc_reimbur_budget_detail ON busi_cc_apply.id=busi_cc_reimbur_budget_detail.expense_id ", "LIKE", "busi_cc_reimbur_budget_detail.project_code", projectCode);
    } else {
      busiCcApply.leftJoin("LEFT JOIN busi_cc_reimbur_budget_detail  ON busi_cc_reimbur_budget_detail.expense_id=`busi_cc_apply`.id");
    } 
    if (!StringUtils.isEmpty(projectName))
      busiCcApply.leftJoinWhere("LEFT JOIN data_project dp ON dp.code=busi_cc_reimbur_budget_detail.project_code", "LIKE", "dp.name", projectName); 
    busiCcApply.setSelectSql("DISTINCT\t`busi_cc_apply`.*");
    String start = request.getParameter("start");
    String end = request.getParameter("end");
    String sumMoneyFrom = request.getParameter("sumMoneyFrom");
    String sumMoneyTo = request.getParameter("sumMoneyTo");
    if (!StringUtils.isEmpty(start))
      busiCcApply.where("GE", "bill_date", start); 
    if (!StringUtils.isEmpty(end))
      busiCcApply.where("LE", "bill_date", end); 
    if (!StringUtils.isEmpty(sumMoneyFrom))
      busiCcApply.where("GE", "sum_money", sumMoneyFrom); 
    if (!StringUtils.isEmpty(sumMoneyTo))
      busiCcApply.where("LE", "sum_money", sumMoneyTo); 
    if (!StringUtils.isEmpty(busiCcApply.getDepartId())) {
      busiCcApply.leftJoinWhere("LEFT JOIN sys_depart ON sys_depart.id=busi_cc_apply.depart_id", "LIKE", "sys_depart.name", busiCcApply.getDepartId());
      busiCcApply.setDepartId(null);
    } 
    if (!StringUtils.isEmpty(busiCcApply.getOperator())) {
      busiCcApply.leftJoinWhere("LEFT JOIN sys_user ON sys_user.id=busi_cc_apply.operator", "LIKE", "sys_user.realname", busiCcApply.getOperator());
      busiCcApply.setOperator(null);
    } 
    if (!StringUtils.isEmpty(busiCcApply.getBudgetYear())) {
      busiCcApply.where("EQ", "budget_year", busiCcApply.getBudgetYear());
      busiCcApply.setBudgetYear(null);
    } else {
      Date newDate = new Date();
      String budgetYear = DateUtils.parseTimeYear(newDate);
      busiCcApply.setBudgetYear(budgetYear);
      busiCcApply.where("EQ", "budget_year", busiCcApply.getBudgetYear());
      busiCcApply.setBudgetYear(null);
    } 
    String ids = getPara("ids", "");
    if (!StringUtils.isEmpty(ids)) {
      String[] split = ids.split(",");
      busiCcApply.where("IN", "id", split);
    } 
    return busiCcApply;
  }
  
  private BusiCcApply getExportData(BusiCcApply busiCcApply, HttpServletRequest request) {
    if ("0".equals(request.getParameter("ccType"))) {
      busiCcApply.setCcType("0");
    } else {
      busiCcApply.setCcType("1");
    } 
    LinkedHashMap<String, String> map = new LinkedHashMap<>();
    map.put("code", "desc");
    map.put("createDate", "desc");
    map.put("billDate", "desc");
    busiCcApply.setOrderMap(map);
    String projectCode = request.getParameter("projectCode");
    String projectName = request.getParameter("projectName");
    if (!StringUtils.isEmpty(projectCode)) {
      busiCcApply.leftJoinWhere("LEFT JOIN busi_cc_reimbur_budget_detail ON busi_cc_apply.id=busi_cc_reimbur_budget_detail.expense_id ", "LIKE", "busi_cc_reimbur_budget_detail.project_code", projectCode);
    } else {
      busiCcApply.leftJoin("LEFT JOIN busi_cc_reimbur_budget_detail  ON busi_cc_reimbur_budget_detail.expense_id=`busi_cc_apply`.id");
    } 
    if (!StringUtils.isEmpty(projectName))
      busiCcApply.leftJoinWhere("LEFT JOIN data_project dp ON dp.code=busi_cc_reimbur_budget_detail.project_code", "LIKE", "dp.name", projectName); 
    busiCcApply.setSelectSql("DISTINCT\t`busi_cc_apply`.*");
    String start = request.getParameter("start");
    String end = request.getParameter("end");
    String sumMoneyFrom = request.getParameter("sumMoneyFrom");
    String sumMoneyTo = request.getParameter("sumMoneyTo");
    if (!StringUtils.isEmpty(start))
      busiCcApply.where("GE", "bill_date", start); 
    if (!StringUtils.isEmpty(end))
      busiCcApply.where("LE", "bill_date", end); 
    if (!StringUtils.isEmpty(sumMoneyFrom))
      busiCcApply.where("GE", "sum_money", sumMoneyFrom); 
    if (!StringUtils.isEmpty(sumMoneyTo))
      busiCcApply.where("LE", "sum_money", sumMoneyTo); 
    if (!StringUtils.isEmpty(busiCcApply.getDepartId())) {
      busiCcApply.leftJoinWhere("LEFT JOIN sys_depart ON sys_depart.id=busi_cc_apply.depart_id", "LIKE", "sys_depart.name", busiCcApply.getDepartId());
      busiCcApply.setDepartId(null);
    } 
    if (!StringUtils.isEmpty(busiCcApply.getOperator())) {
      busiCcApply.leftJoinWhere("LEFT JOIN sys_user ON sys_user.id=busi_cc_apply.operator", "LIKE", "sys_user.realname", busiCcApply.getOperator());
      busiCcApply.setOperator(null);
    } 
    if (!StringUtils.isEmpty(busiCcApply.getBudgetYear())) {
      busiCcApply.where("EQ", "budget_year", busiCcApply.getBudgetYear());
      busiCcApply.setBudgetYear(null);
    } else {
      Date newDate = new Date();
      String budgetYear = DateUtils.parseTimeYear(newDate);
      busiCcApply.setBudgetYear(budgetYear);
      busiCcApply.where("EQ", "budget_year", busiCcApply.getBudgetYear());
      busiCcApply.setBudgetYear(null);
    } 
    this.baseService.dealWithPermissionsCustom((BaseJeeeEntity)busiCcApply, request, "busi_cc_apply.operator", "busi_cc_apply.depart_id");
    return busiCcApply;
  }
  
  private void privateErLongLuParameter(Map<String, Object> vars, BusiCcApply bill) {
    String approvalDepart = "";
    if (vars.get("approvalDepart") != null)
      approvalDepart = vars.get("approvalDepart").toString(); 
    List<BusiCcApplyDetail> detailList1 = bill.getDetailList();
    Set<String> departIdSet = new HashSet<>();
    List<String> skipRoles = new ArrayList<>(Arrays.asList(new String[] { "0003", "0005", "10006" }));
    List<String> roles = new ArrayList<>();
    Set<String> asigneeList = new HashSet<>();
    Set<String> scientificIdList = new HashSet<>();
    Set<String> leaderAssigneeList = new HashSet<>();
    for (BusiCcApplyDetail busiCcApplyDetail : detailList1) {
      String sql = "SELECT\n\tGROUP_CONCAT(sr.role) role, ds.depart_id\nFROM\n\tsys_role sr\n\tLEFT JOIN sys_user_role sur ON sr.id = sur.role_id\n\tLEFT JOIN sys_user su ON su.id = sur.user_id\n\tLEFT JOIN data_staff ds ON su.username = ds.job_num \nWHERE\n\tds.id = ?;";
      List<Map<String, Object>> userServiceListBySql = this.userService.findListBySql(sql, new Object[] { busiCcApplyDetail.getOperatorId() });
      if (listIsNotNull(userServiceListBySql)) {
        label37: for (Map<String, Object> stringObjectMap : userServiceListBySql) {
          String role = (String)stringObjectMap.get("role");
          String departId = (String)stringObjectMap.get("depart_id");
          for (String skipRole : skipRoles) {
            if (role.contains(skipRole))
              break label37; 
          } 
          roles.add("0001");
          List<String> userNameByDepartRole = this.auditService.getUserNameByDepartRole(roles, departId);
          asigneeList.addAll(userNameByDepartRole);
          roles.clear();
          roles.add("0007");
          List<String> userNameByDepartRole1 = this.auditService.getUserNameByDepartRoleCharge(roles, approvalDepart);
          scientificIdList.addAll(userNameByDepartRole1);
          roles.clear();
          roles.add("0003");
          List<String> userNameByDepartRole2 = this.auditService.getUserNameByDepartRole(roles, approvalDepart);
          leaderAssigneeList.addAll(userNameByDepartRole2);
          roles.clear();
        } 
        vars.put("asigneeList", asigneeList);
        vars.put("asigneeListStr", String.join(",", (Iterable)asigneeList));
        Set<String> scientificIdList2 = new HashSet<>();
        for (String userId : scientificIdList) {
          User user = this.userService.get(userId);
          if (user.getDepartId().equals(approvalDepart))
            scientificIdList2.add(userId); 
        } 
        vars.put("scientificIdList", scientificIdList2);
        vars.put("scientificIdListStr", String.join(",", (Iterable)scientificIdList2));
        Set<String> leaderAssigneeList2 = new HashSet<>();
        for (String userId : leaderAssigneeList) {
          User user = this.userService.get(userId);
          if (user.getDepartId().equals(approvalDepart))
            leaderAssigneeList2.add(userId); 
        } 
        vars.put("leaderAssigneeList", leaderAssigneeList2);
        vars.put("leaderAssigneeListStr", String.join(",", (Iterable)leaderAssigneeList2));
      } 
    } 
  }
  
  public List<Map<String, Object>> isExceed3(BusiCcApply entity) {
    List<Map<String, Object>> messageMap = new ArrayList<>();
    String departId = entity.getDepartId();
    String year = entity.getBudgetYear();
    List<String> occupyList = new ArrayList<>();
    List<BusiCcReimburBudgetDetail> budgetDetailList = entity.getBudgetDetailList();
    List<String> codes = (List<String>)budgetDetailList.stream().map(BusiCcReimburBudgetDetail::getProjectCode).distinct().collect(Collectors.toList());
    for (String projectCode : codes) {
      BigDecimal money = BigDecimal.ZERO;
      List<String> budgetProjectList = new ArrayList<>();
      List<BigDecimal> moneyList = new ArrayList<>();
      for (BusiCcReimburBudgetDetail detail : budgetDetailList) {
        if (isNotEmpty(projectCode) && projectCode.equals(detail.getProjectCode())) {
          budgetProjectList.add(detail.getBudgetProjectCode());
          moneyList.add(detail.getExpenseMoney());
          money = money.add(detail.getExpenseMoney());
        } 
      } 
      Map<String, Object> messageMapTmp = new HashMap<>();
      if ("7".equals(entity.getBudgetSources())) {
        messageMapTmp = this.budgetControlService.isExceedKeyanProject(projectCode, money, moneyList, budgetProjectList, occupyList);
      } else {
        messageMapTmp = this.budgetControlService.isExceed(projectCode, money, moneyList, budgetProjectList, departId, year, occupyList, "0");
      } 
      messageMap.add(messageMapTmp);
    } 
    return messageMap;
  }
}
